#include "addressbook.h"
#include "subprogram.h"


class Address
{
	public:
		string name;
		string email;
		string homephone;
		string cellphone;
		string workphone;
		string address;
		string city;
		string state;
		string zip;
		
		void clear();
		
	private:
};

void Address::clear()
{
	name = "";
	email = "";
	homephone = "";
	cellphone = "";
	workphone = "";
	address = "";
	city = "";
	state = "";
	zip = "";
}


extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys, *im_screen;
extern SDL_Surface *img_textbackground, *tmp, *img_view, *img_test;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
extern TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *systemfont;
extern int ndCol, ndLine, nMaxinput; 


extern bool bmUpdate;
extern bool transition, padrelease;
extern int wait, nCol, nLine,mode, menumode;
extern SceCtrlData pad;
extern int blx,bly,blh;
static int inputcursor;

string textscroll;
int entry, bookselect, bookcursor, bookscroll, bookmaxlines = 10;
bool newaddress;
Address address;
vector <Address> book;

void loadBook(void) {
	ifstream file("addressbook.dat");
	string readline;
	int entry=0, loc;
	Address address;
	book.clear();
	
	while (getline(file,readline,'\n')) {
		loc = readline.find((char) 13,0);
		if (loc != string::npos) readline.resize(readline.size()-1);
		if (entry == 0) address.name = readline;
		if (entry == 1) address.email = readline;
		if (entry == 2) address.homephone = readline;
		if (entry == 3) address.cellphone = readline;
		if (entry == 4) address.workphone = readline;
		if (entry == 5) address.address = readline;
		if (entry == 6) address.city = readline;
		if (entry == 7) address.state = readline;
		if (entry == 8) address.zip = readline;
		entry++;
		if (entry == 9) {
			entry = 0;
			book.push_back(address);
		}
	}
	file.close();
}

void saveBook(void) {
	ofstream writefile;
	int count;
	
	writefile.open("addressbook.dat");
	for (count = 0; count < book.size(); count++) {		
		writefile << book[count].name << endl;
		writefile << book[count].email << endl;
		writefile << book[count].homephone << endl;
		writefile << book[count].cellphone << endl;
		writefile << book[count].workphone << endl;
		writefile << book[count].address << endl;
		writefile << book[count].city << endl;
		writefile << book[count].state << endl;
		writefile << book[count].zip << endl;
	}
	writefile.close();
}

void initAddressBook(void) {
	bookscroll = 0;
	bookcursor = 0;
	bookselect = 0;
	if (book.size() == 0) {
		menumode = 2;
		address.clear();
		newaddress = true;
	}
}

int getAddressBookSize(void) {
	return book.size();
}

void getAddressBookInput(void) {
	if (pad.Buttons & PSP_CTRL_UP) {
		if ((bookselect + bookscroll == 0) && bookselect > 0) bookscroll++;
		bookselect--;
		if (bookselect < 0) bookselect = 0;
		bookcursor--;
		if (bookcursor < 0) bookcursor = 0;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((bookselect + bookscroll == bookmaxlines-1) && bookselect < book.size()-1) bookscroll--;
		bookselect++;
		if (bookselect == book.size()) bookselect = book.size()-1;
		bookcursor++;
		if (bookcursor == bookmaxlines) bookcursor = bookmaxlines-1;
		
		if (bookcursor == book.size()) bookcursor = book.size()-1;

		wait = 100;
		bmUpdate = true;
	}
	if (pad.Buttons & PSP_CTRL_CIRCLE && padrelease && !transition && book.size() > 0) {	
		menumode = 1;
		address = book[bookselect];
		padrelease = false;
		wait = 200;
		bmUpdate = true;
		transition = true;
	}	
	if (pad.Buttons & PSP_CTRL_SQUARE && padrelease && !transition && book.size() > 0) {	
		menumode = 2;
		entry = 0;
		newaddress = false;
		address = book[bookselect];
		inputcursor = address.name.size();
		padrelease = false;
		wait = 200;
		bmUpdate = true;
		transition = true;
	}
	if (pad.Buttons & PSP_CTRL_CROSS && padrelease && !transition) {	
		address.clear();
		newaddress = true;
		inputcursor = 0;
		entry = 0;
		menumode = 2;
		padrelease = false;
		wait = 200;
		bmUpdate = true;
		transition = true;
	}	
	if (pad.Buttons & PSP_CTRL_TRIANGLE && !transition && book.size() > 0) {	
		menumode = 3;
		bmUpdate = true;
		transition = true;
	}
}

void displayAddressBook(void) 
{
	int count;
	
	blit(im_screen,0,0, img_background);
	drawMenuFrame(im_screen);
	drawText(systemfont,im_screen,30,161,"Edit:         Delete:           New:        View:",sdlblack);
	drawText(systemfont,im_screen,30,161,"      Square          Triangle       Cross        Circle",sdlblue);
	
	drawText(font,im_screen,198,17,"Address Book", sdlblack);
	
	for (count = 0; count < 10; count++)
	{
		drawHline(im_screen, 35, 45 + count*nLine, 413, lightgrey);
	}
	for (count = 0; count < book.size(); count++) 
	{
		if (book[count].name.size() > 59) 
		{
			textscroll = book[count].name.substr(0,59);
		}
		else 
		{
			textscroll = book[count].name;
		}
		if (bookselect == count) 
		{
			drawFillRect(im_screen,34,35+bookcursor*nLine - 1, 1+textscroll.size() * nCol, nLine, grey);
		}
		if ((bookscroll*nLine + count*nLine) < 120 && (bookscroll*nLine + count*nLine) >= 0) 
		{
			drawText(font,im_screen,35,35+bookscroll*nLine+count*nLine, textscroll, sdlblack);
		}
	}
	blx = 0;
}


void getAddressBookMenuInput(void){
	string readkey;
	int count;
	if (menumode == 1) {
		if (pad.Buttons & PSP_CTRL_SQUARE && padrelease && !transition) {	
			menumode = 2;
			entry = 0;
			newaddress = false;
			address = book[bookselect];
			padrelease = false;
			wait = 200;
			bmUpdate = true;
			transition = true;
		}
		if (pad.Buttons & PSP_CTRL_CROSS && padrelease && !transition) {	
			address.clear();
			newaddress = true;
			entry = 0;
			menumode = 2;
			padrelease = false;
			wait = 200;
			bmUpdate = true;
			transition = true;
		}	
		if (pad.Buttons & PSP_CTRL_TRIANGLE && !transition) {	
			menumode = 3;
			bmUpdate = true;
			transition = true;
		}
	}

	if (menumode == 2) {
		if (padUp()) {
			if (entry == 0) entry = 8;
			else entry--;
			wait = 120;
			bmUpdate = true;
			if (entry == 0) count = address.name.size();
			else if (entry == 1) count = address.email.size();
			else if (entry == 2) count = address.homephone.size();
			else if (entry == 3) count = address.cellphone.size();
			else if (entry == 4) count = address.workphone.size();
			else if (entry == 5) count = address.address.size();
			else if (entry == 6) count = address.city.size();
			else if (entry == 7) count = address.state.size();
			else if (entry == 8) count = address.zip.size();
			inputcursor = count;			
		}
		if (padDown()) {
			if (entry == 8) entry = 0;
			else entry++;
			wait = 120;
			bmUpdate = true;
			if (entry == 0) count = address.name.size();
			else if (entry == 1) count = address.email.size();
			else if (entry == 2) count = address.homephone.size();
			else if (entry == 3) count = address.cellphone.size();
			else if (entry == 4) count = address.workphone.size();
			else if (entry == 5) count = address.address.size();
			else if (entry == 6) count = address.city.size();
			else if (entry == 7) count = address.state.size();
			else if (entry == 8) count = address.zip.size();
			inputcursor = count;						
		}
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (entry == 0) count = address.name.size();
			else if (entry == 1) count = address.email.size();
			else if (entry == 2) count = address.homephone.size();
			else if (entry == 3) count = address.cellphone.size();
			else if (entry == 4) count = address.workphone.size();
			else if (entry == 5) count = address.address.size();
			else if (entry == 6) count = address.city.size();
			else if (entry == 7) count = address.state.size();
			else if (entry == 8) count = address.zip.size();
			if (inputcursor < count) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}		
		}	
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    return;
  }
# endif
		if (readkey != "") {
			if (readkey == "     ") {
				if (entry < 8) entry ++;
				else entry = 0;
				if (entry == 0) count = address.name.size();
				else if (entry == 1) count = address.email.size();
				else if (entry == 2) count = address.homephone.size();
				else if (entry == 3) count = address.cellphone.size();
				else if (entry == 4) count = address.workphone.size();
				else if (entry == 5) count = address.address.size();
				else if (entry == 6) count = address.city.size();
				else if (entry == 7) count = address.state.size();
				else if (entry == 8) count = address.zip.size();
				inputcursor = count;
			}
			else if (readkey == "bs") {
				if (entry == 0) {
					if (inputcursor > 0 && address.name.size() > 0) {
						address.name.erase(inputcursor-1,1);
						inputcursor--;
					}
				}
				else if (entry == 1) {
					if (inputcursor > 0 && address.email.size() > 0) {
						address.email.erase(inputcursor-1,1);
						inputcursor--;
					}}
				else if (entry == 2) {
					if (inputcursor > 0 && address.homephone.size() > 0) {
						address.homephone.erase(inputcursor-1,1);
						inputcursor--;
					}
				}
				else if (entry == 3) {
					if (inputcursor > 0 && address.cellphone.size() > 0) {
						address.cellphone.erase(inputcursor-1,1);
						inputcursor--;
					}				
				}				
				else if (entry == 4) {
					if (inputcursor > 0 && address.workphone.size() > 0) {
						address.workphone.erase(inputcursor-1,1);
						inputcursor--;
					}				
				}
				else if (entry == 5) {
					if (inputcursor > 0 && address.address.size() > 0) {
						address.address.erase(inputcursor-1,1);
						inputcursor--;
					}				
				}
				else if (entry == 6) {
					if (inputcursor > 0 && address.city.size() > 0) {
						address.city.erase(inputcursor-1,1);
						inputcursor--;
					}				
				}
				else if (entry == 7) {
					if (inputcursor > 0 && address.state.size() > 0) {
						address.state.erase(inputcursor-1,1);
						inputcursor--;
					}				
				}
				else if (entry == 8) {
					if (inputcursor > 0 && address.zip.size() > 0) {
						address.zip.erase(inputcursor-1,1);
						inputcursor--;
					}				
				}				
			}
			else if (readkey == "en") {
				if (address.name.size() > 0) {
					if (!newaddress) {
						if (address.name == book[bookselect].name) book[bookselect] = address;
						else {
							book.erase(book.begin() + bookselect);
							count = 0;
							while (address.name != book[count].name && count < book.size()) {
								count++;
								if (count == book.size()) break;
							}
							if (count < book.size()) {
								time_t tTime;
								time ( &tTime);
								char sizestring[300];
								sprintf(sizestring,"%s (%d)",address.name.c_str(),tTime);
								address.name = sizestring;
							}
							count = 0;
							while (address.name > book[count].name && count < book.size()) {
								count++;
								if (count == book.size()) break;
							}
							if (count == book.size()) book.push_back(address);
							else book.insert(book.begin() + count,address);
						}
					}
					else {
						if (book.size() == 0) book.push_back(address);
						else {
							count = 0;
							while (address.name != book[count].name && count < book.size()) {
								count++;
								if (count == book.size()) break;
							}
							if (count < book.size()) {
								time_t tTime;
								time ( &tTime);
								char sizestring[300];
								sprintf(sizestring,"%s (%d)",address.name.c_str(),tTime);
								address.name = sizestring;
							}					
							count = 0;
							while (address.name > book[count].name && count < book.size()) {
								count++;
								if (count == book.size()) break;
							}
							if (count == book.size()) book.push_back(address);
							else book.insert(book.begin() + count,address);
						}
						
					}
					bookselect = 0;
					bookcursor = 0;
					bookscroll = 0;
					menumode = 0;
					saveBook();
					transition = true;
					inputcursor = 0;
				}	
			}
			else  {
				if (entry == 0) {
					if (address.name.size() < 255) {
						address.name.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry == 1) {
					if (address.email.size() < 255) {
						address.email.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry == 2){
					if (address.homephone.size() < 14)
						if (isdigit((int) *readkey.c_str()) || readkey == "(" || readkey == ")" || readkey == " " || readkey == "-") {
							address.homephone.insert(inputcursor,readkey);
							inputcursor++;
						}
				}
				else if (entry == 3) {
					if (address.cellphone.size() < 14) {
						address.cellphone.insert(inputcursor,readkey);
						inputcursor++;
					}
				}				
				else if (entry == 4) {
					if (address.workphone.size() < 14) {
						address.workphone.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry == 5) {
					if (address.address.size() < 255) {
						address.address.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry == 6) {
					if (address.city.size() < 255) {
						address.city.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry == 7) {
					if (address.state.size() < 2 && isalpha((int) *readkey.c_str())) {
						address.state.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry == 8) {
					if (address.zip.size() < 5 && isdigit((int) *readkey.c_str())) {
						address.zip.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
			}
			bmUpdate = true;
		}
	}

	if (menumode == 3) {
		if (pad.Buttons & PSP_CTRL_CROSS) {
			book.erase(book.begin() + bookselect);
			saveBook();
			menumode = 0;
			if (book.size() == 0) {
				menumode = 2;
				address.clear();
				newaddress = true;
			}
			bmUpdate = true;
			transition = true;
		}
	}
}



void displayAddressBookMenu(void){
	if (menumode == 1) {
		blit(im_screen,0,0, img_background);
		drawMenuFrame(im_screen);
		drawText(systemfont,im_screen,30,161,"Edit:         Delete:           New:",sdlblack);
		drawText(systemfont,im_screen,30,161,"      Square          Triangle       Cross",sdlblue);	
		
		drawText(font,im_screen,205,17,"View Entry", sdlblack);
		
		drawText(font,im_screen,40, 50, "Name:",sdlblack);
		drawRect(im_screen,99,47,342,16,black);
		drawRect(im_screen,98,46,342,16,grey);		
		if (address.name.size() > 48) textscroll = address.name.substr(0,48);
		else textscroll = address.name;
		drawText(font,im_screen,100,50, textscroll, sdlblack);

		
		drawText(font,im_screen,40, 70, "E-Mail:",sdlblack);
		drawRect(im_screen,99,67,180,16,black);
		drawRect(im_screen,98,66,180,16,grey);		
		if (address.email.size() > 25) textscroll = address.email.substr(0,25);
		else textscroll = address.email;		
		drawText(font,im_screen,100,70, textscroll, sdlblack);
		
		drawText(font,im_screen,282, 70, "Home #:",sdlblack);
		drawRect(im_screen,99,87,100,16,black);
		drawRect(im_screen,98,86,100,16,grey);	
		drawText(font,im_screen,100,90,address.homephone, sdlblack);		
		
		drawText(font,im_screen,40, 90, "Cell #:",sdlblack);
		drawRect(im_screen,341,67,100,16,black);
		drawRect(im_screen,340,66,100,16,grey);	
		drawText(font,im_screen,342,70,address.cellphone, sdlblack);

		
		drawText(font,im_screen,282, 90, "Work #:",sdlblack);	
		drawRect(im_screen,341,87,100,16,black);
		drawRect(im_screen,340,86,100,16,grey);		
		drawText(font,im_screen,342,90, address.workphone, sdlblack);

		
		drawText(font,im_screen,40, 110, "Address:",sdlblack);
		drawRect(im_screen,99,107,342,16,black);
		drawRect(im_screen,98,106,342,16,grey);		
		if (address.address.size() > 48) textscroll = address.address.substr(0,48);
		else textscroll = address.address;		
		drawText(font,im_screen,100,110, textscroll, sdlblack);

		
		drawText(font,im_screen,40, 130, "City:",sdlblack);
		drawRect(im_screen,99,127,180,16,black);
		drawRect(im_screen,98,126,180,16,grey);		
		if (address.city.size() > 25) textscroll = address.city.substr(0,25);
		else textscroll = address.city;
		drawText(font,im_screen,100,130, textscroll, sdlblack);

		
		drawText(font,im_screen,288, 130, "State:",sdlblack);
		drawRect(im_screen,339,127,20,16,black);
		drawRect(im_screen,338,126,20,16,grey);		
		drawText(font,im_screen,340,130, address.state, sdlblack);


		drawText(font,im_screen,364, 130, "Zip:",sdlblack);
		drawRect(im_screen,401,127,40,16,black);
		drawRect(im_screen,400,126,40,16,grey);		
		drawText(font,im_screen,402,130, address.zip, sdlblack);

		blx = 0;
	}
	
	if (menumode == 2) {
		blit(im_screen,0,0, img_background);
		drawMenuFrame(im_screen);
		drawKeyboard(im_screen);	
		
		if (!newaddress) drawText(font,im_screen,205,17,"Edit Entry", sdlblack);
		else drawText(font,im_screen,205,17,"New Entry", sdlblack);
		
		drawText(font,im_screen,40, 50, "Name:",sdlblack);
		if (entry != 0) drawFillRect(im_screen,98,46,344,16,grey);
		drawRect(im_screen,99,47,344,16,black);
		drawRect(im_screen,98,46,344,16,grey);		
		if (address.name.size() > 48) {
			if (entry == 0) {
				if (inputcursor < address.name.size() - 48) textscroll = address.name.substr(inputcursor,48);
				else textscroll = address.name.substr(address.name.size()-48);
			}
			else textscroll = address.name.substr(0,48);
		}
		else textscroll = address.name;
		drawText(font,im_screen,100,50, textscroll, sdlblack);
		if (entry == 0) {
			//drawVline(im_screen,100+textscroll.size()*nCol, 48, nLine, cursorcol);
			if (address.name.size() <= 48) blx = 100+inputcursor*nCol;
			else {
				if (inputcursor < address.name.size() - 48) blx = 100;
				else blx = 100+(48)*nCol-address.name.size()*nCol+inputcursor*nCol;
			}
			bly = 48;
			blh = nLine;
			drawText(systemfont,im_screen,32,161,"Press Tab to modify E-mail.  Press Enter when done",sdlblue);
		}

		
		drawText(font,im_screen,40, 70, "E-Mail:",sdlblack);	
		if (entry != 1) drawFillRect(im_screen,98,66,182,16,grey);
		drawRect(im_screen,99,67,182,16,black);
		drawRect(im_screen,98,66,182,16,grey);	
		if (address.email.size() > 25) {
			if (entry == 1) {
				if (inputcursor < address.email.size() - 25) textscroll = address.email.substr(inputcursor,25);
				else textscroll = address.email.substr(address.email.size()-25);
			}
			else textscroll = address.email.substr(0,25);
		}		
		else textscroll = address.email;		
		drawText(font,im_screen,100,70, textscroll, sdlblack);
		if (entry == 1) {
			//drawVline(im_screen,100+textscroll.size()*nCol, 68, nLine, cursorcol);
			if (address.email.size() <= 25) blx = 100+inputcursor*nCol;
			else {
				if (inputcursor < address.email.size() - 25) blx = 100;
				else blx = 100+(25)*nCol-address.email.size()*nCol+inputcursor*nCol;
			}
			bly = 68;
			blh = nLine;
			drawText(systemfont,im_screen,32,161,"Press Tab to modify Home #.  Press Enter when done",sdlblue);
		}
		
		drawText(font,im_screen,282, 70, "Home #:",sdlblack);	
		if (entry != 2) drawFillRect(im_screen,340,66,102,16,grey);
		drawRect(im_screen,341,67,102,16,black);
		drawRect(im_screen,340,66,102,16,grey);	
		drawText(font,im_screen,342,70,address.homephone, sdlblack);
		if (entry == 2) {
			//drawVline(im_screen,100+address.homephone.size()*nCol, 88, nLine, cursorcol);
			blx = 342+inputcursor*nCol;
			bly = 68;
			blh = nLine;			
			drawText(systemfont,im_screen,32,161,"Press Tab to modify Cell #.  Press Enter when done",sdlblue);
		}
		
		drawText(font,im_screen,40, 90, "Cell #:",sdlblack);	
		if (entry != 3) drawFillRect(im_screen,98,86,102,16,grey);
		drawRect(im_screen,99,87,102,16,black);
		drawRect(im_screen,98,86,102,16,grey);	
		drawText(font,im_screen,100,90,address.cellphone, sdlblack);
		if (entry == 3) {
			//drawVline(im_screen,100+address.cellphone.size()*nCol, 88, nLine, cursorcol);
			blx = 100+inputcursor*nCol;
			bly = 88;
			blh = nLine;			
			drawText(systemfont,im_screen,32,161,"Press Tab to modify Work #.  Press Enter when done",sdlblue);
		}		

		
		drawText(font,im_screen,282, 90, "Work #:",sdlblack);	
		if (entry != 4) drawFillRect(im_screen,340,86,102,16,grey);
		drawRect(im_screen,341,87,102,16,black);
		drawRect(im_screen,340,86,102,16,grey);
		drawText(font,im_screen,342,90, address.workphone, sdlblack);
		if (entry == 4) {
			//drawVline(im_screen,342+address.workphone.size()*nCol, 88, nLine, cursorcol);
			blx = 342+inputcursor*nCol;
			bly = 88;
			blh = nLine;				
			drawText(systemfont,im_screen,32,161,"Press Tab to modify Address.  Press Enter when done",sdlblue);
		}

		
		drawText(font,im_screen,40, 110, "Address:",sdlblack);	
		if (entry != 5) drawFillRect(im_screen,98,106,344,16,grey);
		drawRect(im_screen,99,107,344,16,black);
		drawRect(im_screen,98,106,344,16,grey);			
		if (address.address.size() > 48) {
			if (entry == 5) {
				if (inputcursor < address.address.size() - 48) textscroll = address.address.substr(inputcursor,48);
				else textscroll = address.address.substr(address.address.size()-48);
			}
			textscroll = address.address.substr(0,48);
		}			
		else textscroll = address.address;		
		drawText(font,im_screen,100,110, textscroll, sdlblack);
		if (entry == 5) {
			//drawVline(im_screen,100+textscroll.size()*nCol, 108, nLine, cursorcol);
			if (address.address.size() <= 48) blx = 100+inputcursor*nCol;
			else {
				if (inputcursor < address.address.size() - 48) blx = 100;
				else blx = 100+(48)*nCol-address.address.size()*nCol+inputcursor*nCol;
			}
			bly = 108;
			blh = nLine;				
			drawText(systemfont,im_screen,32,161,"Press Tab to modify City.  Press Enter when done",sdlblue);
		}

		
		drawText(font,im_screen,40, 130, "City:",sdlblack);	
		if (entry != 6) drawFillRect(im_screen,98,126,182,16,grey);
		drawRect(im_screen,99,127,182,16,black);
		drawRect(im_screen,98,126,182,16,grey);	
		if (address.city.size() > 25) {
			if (entry == 6) {
				if (inputcursor < address.city.size() - 25) textscroll = address.city.substr(inputcursor,25);
				else textscroll = address.city.substr(address.city.size()-25);
			}
			else textscroll = address.city.substr(0,25);
		}		
		else textscroll = address.city;		
		drawText(font,im_screen,100,130, textscroll, sdlblack);
		if (entry == 6) {
			//drawVline(im_screen,100+textscroll.size()*nCol, 68, nLine, cursorcol);
			if (address.city.size() <= 25) blx = 100+inputcursor*nCol;
			else {
				if (inputcursor < address.city.size() - 25) blx = 100;
				else blx = 100+(25)*nCol-address.city.size()*nCol+inputcursor*nCol;
			}
			bly = 128;
			blh = nLine;
			drawText(systemfont,im_screen,32,161,"Press Tab to modify State #.  Press Enter when done",sdlblue);
		}

		
		drawText(font,im_screen,288, 130, "State:",sdlblack);	
		if (entry != 7) drawFillRect(im_screen,338,126,22,16,grey);
		drawRect(im_screen,339,127,22,16,black);
		drawRect(im_screen,338,126,22,16,grey);			
		drawText(font,im_screen,340,130, address.state, sdlblack);
		if (entry == 7) {
			//drawVline(im_screen,340+address.state.size()*nCol, 128, nLine, cursorcol);
			blx = 340+inputcursor*nCol;
			bly = 128;
			blh = nLine;
			drawText(systemfont,im_screen,32,161,"Press Tab to modify Zip.  Press Enter when done",sdlblue);
		}


		drawText(font,im_screen,364, 130, "Zip:",sdlblack);
		if (entry != 8) drawFillRect(im_screen,400,126,42,16,grey);
		drawRect(im_screen,401,127,42,16,black);		
		drawRect(im_screen,400,126,42,16,grey);		
		drawText(font,im_screen,402,130, address.zip, sdlblack);
		if (entry == 8) {
			//drawVline(im_screen,402+address.zip.size()*nCol, 128, nLine, cursorcol);
			blx = 402+inputcursor*nCol;
			bly = 128;
			blh = nLine;
			drawText(systemfont,im_screen,32,161,"Press Tab to modify Name.  Press Enter when done",sdlblue);
		}
		
	}
	
	if (menumode == 3) {
		drawMenuFrame(im_screen);
		
		drawFillRect(im_screen,176,46,260,16,grey);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);

		drawText(font,im_screen, 40, 50, "Delete Entry:",sdlblack);
		
		if (book[bookselect].name.size() > nMaxinput) textscroll = book[bookselect].name.substr(book[bookselect].name.size()-nMaxinput);
		else textscroll = book[bookselect].name;
		drawText(font,im_screen,180,50, textscroll.c_str(), sdlblack);
		
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Cross to delete", sdlblue);
		drawText(font,im_screen,194,17,"OK to delete?", sdlblack);
		blx = 0;
	}
}

