#include "subprogram.h"
#include "notepad.h"

extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen, *im_screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys, *img_calckeys;
extern SDL_Surface *img_textbackground, *img_menubar, *tmp, *img_view, *img_test;
extern SDL_Surface *img_addressbookicon, *img_fileicon, *img_calendaricon, *img_calculatoricon, *img_notepadicon, *img_musicicon, *img_photoicon, *img_clockicon, *img_settingsicon;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;

vector <string> text;
vector <string> wraptext;
vector <int> bookmark, bookmark2;
int current = -1, current2 = -1;

extern TTF_Font *font, *drawfont, *systemfont;
extern int ndCol, ndLine, nFontsize, minlines, maxlines, nMaxinput; 

extern bool bUpdate, bmUpdate, isplaying;
extern bool transition, padrelease;
bool wordwrap, wordwrap1, wordwrap2;
int cursor, scrollx, scrolly, line = 0, insertline;
extern int wait, nMaxchar, nKeyset, nCol, nLine, mode, menumode, menu, menucursor, lastmode;
int  num, nWW, testline;
extern int blx, bly, blh;
vector <string> copytext;
string findtext, textfile;
string replacetext, deletefile, gotoline;

static int colcursor;
int findfirst, findline, findlast;

extern int dircursor, dirscroll, dirselect, dirmaxlines, directorymode;
string savefile;
bool bTabbed = false;
extern vector <Dir> dir;
extern string currentdir, upcurrentdir, filedir;
extern SceCtrlData pad;

int mark1[2], mark2[2], temp[2];
static int inputcursor;
string openfile = "Untitled.doc";
vector <string> bookmarkdat;

void initNotepad(void)
{
	text.clear();
	text.push_back("");
	line = 0;
	cursor = 0;
	scrollx = 0;
	scrolly = 0;
	bookmark.clear();
	bookmark2.clear();
	current = -1;
	current2 = -1;
	mark1[0] = -1;
	mark1[1] = -1;
	mark2[0] = -1;
	mark2[1] = -1;
	openfile = "Untitled.doc";
}

void loadText(void)
{
	string readfile, readline;
	int loc;
	ifstream file;
	
	text.clear();
	cursor = 0;
	scrollx = 0;
	scrolly = 0;
	current = -1;
	current = -1;
	bookmark.clear();
	bookmark2.clear();
	mark1[0] = -1;
	mark1[1] = -1;
	mark2[0] = -1;
	mark2[1] = -1;
	line = 0;

	readfile = currentdir + "/" + dir[dirselect].name;
	openfile = dir[dirselect].name;
	file.open(readfile.c_str());
	while (getline(file,readline,'\n')) {
		
		loc = readline.find((char) 13,0);
		if (loc != string::npos) readline.resize(readline.size()-1);
		loc = readline.find((char) 9,0);
		while (loc != string::npos) {
			readline.replace(loc,1,"     ");
			loc = readline.find((char) 9,0);
		}
		text.push_back(readline);
	}
	file.close();
	if (text.size() < 1) text.push_back("");
	loadBookmarks(readfile);
	textfile = readfile;
	update();
	if (wordwrap) {
		if (wordwrap2) { textWrap2(); }
		else { textWrap1(); }
	}
}

void saveText()
{
	savefile = openfile;
	inputcursor = savefile.size();
}

void getKeyboardInput(void)
{
	string readkey;
	int count;
	
	readKeyboard();
	readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    mode = EDIT;
    return;
  }
# endif
	if (readkey != "") {
		if (readkey == "bs") {
			if (cursor == text[line].size()+1) 
				text[line] = text[line].substr( 0, text[line].size() - 1);
			else if (cursor > 0)
				text[line] = text[line].substr( 0, cursor - 1) + text[line].substr(cursor, text[line].size() - 1);
				
			cursor--;
			if (cursor < 0 && line > 0) {
				line--;
				cursor = text[line].size();
				if (text[line+1].size() > 0) text[line] = text[line] + text[line+1];
				text.erase(text.begin()+line+1);
			}
			if (cursor < 0) cursor = 0;
			if (line + scrolly < 0) scrolly = scrolly + 4;
			if (cursor + scrollx == 0) scrollx = scrollx + 4;
			if (scrollx > 0) scrollx = 0;
			if (scrolly > 0) scrolly = 0;
		}
		else if (readkey == "en") {
				if (line == text.size() - 1) {
					text.resize(text.size()+1,"");
					if (cursor < text[line].size()) {
						text[line+1] = text[line].substr(cursor);
						text[line] = text[line].substr(0,cursor);
					}
					line++;
					cursor = 0;
				}
				if (line < text.size() - 1) {
					text.resize(text.size()+1);
					count = text.size()-1;
					while (count > line) {
						text[count] = text[count - 1];
						count--;
					}
					if (cursor < text[line].size()) {
						text[line+1] = text[line].substr(cursor);
						text[line] = text[line].substr(0,cursor);
					}
					else text[line+1] = "";
					line++;
					cursor = 0;
					scrollx = 0;
				}
				if (line + scrolly > minlines - 1) scrolly--;
		}				
		else {
			text[line].insert(cursor,readkey);

			cursor++;
			if (readkey == "     ") cursor = cursor + 4;
			
			if (cursor > (nMaxchar - 2) - scrollx) scrollx = scrollx - 4;
		}
		if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor + 4;
		if (scrollx > 0) scrollx = 0;
		if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line + 4;
		//if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size() + 4;
		if (scrolly > 0) scrolly = 0;

		update();
	}
}

void getEditInput(void)
{
	int findfirst = 0, findlast = 0;
	
	if (pad.Buttons & PSP_CTRL_UP) {
		line--;
		if (line < 0) line = 0;
		if (cursor > text[line].size()) cursor = text[line].size();
		if ((line + scrolly) < 0) scrolly++;
		if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar-1)) scrollx = 0 - cursor;
		if ((line + scrolly < 0) || (line + scrolly > minlines-1)) scrolly = 0 - line;
		//if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();

		update();
		wait = 60;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		line++;
		if (line == text.size()) line = text.size()-1;
		if (cursor > text[line].size()) cursor = text[line].size();
		if (line + scrolly > minlines - 1 && line < text.size()) scrolly = scrolly--;
		if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
		if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
		//if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();
		update();
		wait = 60;
	}
	
	if (pad.Buttons & PSP_CTRL_LEFT) {
		cursor--;
		if (cursor < 0 && line == 0 && scrollx >= 0) cursor = 0;
		if (cursor < 0 && line > 0 && scrollx >= 0) {
			line--;
			cursor = text[line].size();
		}
		if ((cursor + scrollx) < 0) {
			scrollx = scrollx + 4;
			if (scrollx > 0) {
				scrollx = 0;
			}
		}
		if (cursor > (nMaxchar - 2 - scrollx)) scrollx = scrollx - 4;
		if (scrollx > 0) scrollx = 0;
		if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar - 1)) scrollx = 0 - cursor;
		if ((line + scrolly < 0) || (line + scrolly > minlines - 1)) scrolly = 0 - line;
		//if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();				

		update();
		wait = 60;
	}
	
	if (pad.Buttons & PSP_CTRL_RIGHT) {
		cursor++;
		if (cursor > text[line].size() && line < text.size() - 1) {
			cursor = 0;
			line++;
		}
		if (cursor > text[line].size() && line == text.size() - 1) cursor = text[line].size();
		if ((cursor + scrollx) < 0) scrollx = scrollx + 4;
		
		if (cursor > (nMaxchar - 2 - scrollx)) scrollx = scrollx - 4;
		if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar - 1)) scrollx = 0 - cursor;
		if ((line + scrolly < 0) || (line + scrolly > minlines - 1)) scrolly = 0 - line;
		//if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();				
		update();
		wait = 60;
	}

	if (pad.Buttons & PSP_CTRL_RTRIGGER && text.size() > minlines) {
		line = line + minlines - 1;
		scrolly = scrolly - minlines + 1;
		if (line + minlines > text.size()) {
			if (line >= text.size()) line = text.size()-1;
			scrolly = minlines - text.size();
		}
		if (cursor > text[line].size()) {
			cursor = text[line].size();
		}
		update();
		wait = 80;
	}
	if (pad.Buttons & PSP_CTRL_LTRIGGER) {
		line = line - minlines + 1;
		scrolly = scrolly + minlines - 1;
		if ((line - minlines - 1) < 0) {
			if (line < 0) line = 0;
			scrolly = 0;
		}
		if (cursor > text[line].size()) {
			cursor = text[line].size();
		}
		update();
		wait = 80;
	}

	if (padrelease) {

		if (pad.Buttons & PSP_CTRL_TRIANGLE) {
			if (mark2[0] != -1) {
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
			}
			else if (mark1[0] == -1) {
				mark1[0] = cursor;
				mark1[1] = line;
			}
			else if (mark1[0] != -1) {
				mark2[0] = cursor;
				mark2[1] = line;
				if ((mark2[0] < mark1[0] && mark2[1] <= mark1[1]) || (mark2[1]  < mark1[1])) {
					temp[0] = mark1[0];
					temp[1] = mark1[1];
					mark1[0] = mark2[0];
					mark1[1] = mark2[1];
					mark2[0] = temp[0];
					mark2[1] = temp[1];
				}					 			
			}	
			if (mark1[0] == mark2[0] && mark1[1] == mark2[1]) {
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
			}
			update();
			wait = 200;
			padrelease = false;
		}


		if (pad.Buttons & PSP_CTRL_SQUARE) {
			findfirst = text[line].find_first_not_of(" ");
			if (findfirst == string::npos) {
				findfirst = 0;
			}
			if (cursor != findfirst && findfirst != 0) {				
				cursor = findfirst;
				if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar - 1)) scrollx = nMaxchar - cursor - 4;	
			}
			else {
				cursor = 0;
				scrollx = 0;
			}
			
			if (line < 0 - scrolly || line > minlines - scrolly - 1) scrolly = 0 - line + 4;
			if (scrolly > 0) scrolly = 0;
			
			update();
			wait = 200;
			padrelease = false;
		}

		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			cursor = text[line].size();
			if (cursor + scrollx < 0 || cursor + scrollx > nMaxchar - 1) scrollx = nMaxchar - cursor - 4;
			if (scrollx > 0) scrollx = 0;
			if (line < 0 - scrolly || line > minlines - scrolly - 1) scrolly = 0 - line + 4;
			if (scrolly > 0) scrolly = 0;
			update();
			padrelease = false;
		}
	}
}

void getFullscreenInput(void)
{
	if (wordwrap) {
		num = nWW;
	}
	else {
		num = text.size();
	}

	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((num + scrolly) > minlines && mode < 3) {
			scrolly--;
			wait = 10;
		}
		if ((num + scrolly) > maxlines && mode == 3) {
			scrolly--;
			wait = 10;
		}
		update();
	}
	if (pad.Buttons & PSP_CTRL_UP) {
		if (scrolly != 0) {
			scrolly++;
			wait = 10;
		}
		update();
	}

	if (!wordwrap) {
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			scrollx--;
			wait = 10;
			update();
		}
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (scrollx != 0) {
				scrollx++;
				wait = 10;
			}
			update();
		}
	}
			
	if (pad.Buttons & PSP_CTRL_RTRIGGER && num > maxlines) {
		scrolly = scrolly - maxlines + 1;
		if (scrolly + num < maxlines) {
			scrolly = maxlines - num;
		}
		update();
		wait = 80;
	}
	if (pad.Buttons & PSP_CTRL_LTRIGGER) {
		scrolly = scrolly + maxlines - 1;
		if (scrolly > 0) scrolly = 0;

		update();
		wait = 80;
	}
}

void getNotepadInput(void)
{
	if (mode == KEYBOARD && nKeyset == 1) {
		if (mode != 3 || (mode == 3 && !wordwrap)) {
			if (pad.Buttons & PSP_CTRL_LEFT) {
				if (scrollx != 0) {
					scrollx++;
					wait = 10;
				}
				update();			
			}		
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				scrollx--;
				wait = 10;
				update();
			}
		}
		
		if (pad.Buttons & PSP_CTRL_UP) {
			if (scrolly != 0) {
				scrolly++;
				wait = 10;
			}
			update();
		}
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (wordwrap) num = nWW;
			else num = text.size();
			if ((num + scrolly) > minlines && mode < FULLSCREEN) {
				scrolly--;
				wait = 10;
			}
			if ((num + scrolly) > maxlines && mode == FULLSCREEN) {
				scrolly--;
				wait = 10;
			}
			update();
		}
	}
	
	if (mode >= KEYBOARD && mode <= FULLSCREEN && !(mode == KEYBOARD && nKeyset==1)) {
		if (mode != FULLSCREEN || (mode == FULLSCREEN && !wordwrap)) {
			if (pad.Lx == 0) {
				if (scrollx != 0) {
					scrollx++;
					wait = 10;
				}
				update();			
			}		
			if (pad.Lx == 255) {
				scrollx--;
				wait = 10;
				update();
			}
		}
	
		if (pad.Ly == 0) {
			if (scrolly != 0) {
				scrolly++;
				wait = 10;
			}
			update();
		}
		if (pad.Ly == 255) {
			if (wordwrap) num = nWW;
			else num = text.size();
			if ((num + scrolly) > minlines && mode < FULLSCREEN) {
				scrolly--;
				wait = 10;
			}
			if ((num + scrolly) > maxlines && mode == FULLSCREEN) {
				scrolly--;
				wait = 10;
			}
			update();
		}
	}
}

void getEditMenuInput(void)
{
	int count;
	string temptext;
	bool found = false;
	
	if (padrelease) {
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			menu = 3;
			if (mode < 5) mode = lastmode;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			menu = 1;
			if (mode < 5) mode = lastmode;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
	}		
	
	if (pad.Buttons & PSP_CTRL_UP) {
		if (menucursor == 1) menucursor = 9;
		else menucursor--;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if (menucursor == 9)  menucursor = 1;
		else menucursor++;
		wait = 100;
		bmUpdate = true;
	}	

	if (pad.Buttons & PSP_CTRL_CROSS && mode < 4) {

		if (menucursor == 1 && mark2[0] != -1) {
			copytext.clear();
			if (mark2[1] == mark1[1]) copytext.push_back(text[mark1[1]].substr(mark1[0], mark2[0] - mark1[0]));
			
			if (mark2[1] > mark1[1]) {
				for (count = mark1[1]; count <= mark2[1]; count++) {
					if (count == mark2[1]) copytext.push_back(text[count].substr(0, mark2[0]));
					else if (count == mark1[1]) copytext.insert(copytext.begin(),text[count].substr(mark1[0]));							
					else copytext.push_back(text[count]);
				}
			}
			
			if (mark2[1] == mark1[1]) {
				text[mark1[1]].erase(mark1[0],mark2[0]-mark1[0]);
			}
			
			if (mark2[1] > mark1[1]) {	
				text[mark1[1]].erase(mark1[0]);
				
				text[mark2[1]] = text[mark2[1]].substr(mark2[0]);
				
				text[mark1[1]] = text[mark1[1]]+text[mark2[1]];
				text.erase(text.begin()+mark2[1]);
				if (mark2[1] - mark1[1] > 1) {
					for (count = mark1[1]+1; count<=mark2[1]-1;count++) text.erase(text.begin()+count);
				}
			}
			cursor = mark1[0];
			line = mark1[1];

			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
			if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();
				
			mark1[0] = -1;
			mark1[1] = -1;
			mark2[0] = -1;
			mark2[1] = -1;
			update();
		}

		if (menucursor == 2 && mark2[1] != -1) {
			copytext.clear();
			if (mark2[1] == mark1[1]) copytext.push_back(text[mark1[1]].substr(mark1[0], mark2[0] - mark1[0]));
			
			if (mark2[1] > mark1[1]) {
				for (count = mark1[1]; count <= mark2[1]; count++) {
					if (count == mark2[1]) copytext.push_back(text[count].substr(0, mark2[0]));
					else if (count == mark1[1]) copytext.insert(copytext.begin(),text[count].substr(mark1[0]));							
					else copytext.push_back(text[count]);
				}
			}				
		}			
		
		if (menucursor == 3 && !copytext.empty() && copytext[0].size() > 0) {
			if (mark2[1] != -1 ) {
				if (mark2[1] == mark1[1]) {
					text[mark1[1]].erase(mark1[0],mark2[0]-mark1[0]);
				}
				
				if (mark2[1] > mark1[1]) {	
					text[mark1[1]].erase(mark1[0]);
					
					text[mark2[1]] = text[mark2[1]].substr(mark2[0]);
					
					text[mark1[1]] = text[mark1[1]]+text[mark2[1]];
					text.erase(text.begin()+mark2[1]);
					if (mark2[1] - mark1[1] > 1) {
						for (count = mark1[1]+1; count<=mark2[1]-1;count++) text.erase(text.begin()+count);
					}
				}
				cursor = mark1[0];
				line = mark1[1];
			}
			
			if (copytext.size() == 1) text[line].insert(cursor,copytext[0]);
			
			if (copytext.size() > 1 ) {
				if (cursor == 0) {
					temptext = copytext[copytext.size()-1] + text[line];
					text[line] = copytext[0];
					text.insert(text.begin()+line+1, temptext);
				}
				else if (cursor == text[line].size()) {
					text[line] = text[line]+copytext[0];
					text.insert(text.begin()+line+1, copytext[copytext.size()-1]);
				}
				else {
					temptext = copytext[copytext.size()-1]+text[line].substr(cursor);
					text[line] = text[line].substr(0,cursor)+copytext[0];
					text.insert(text.begin()+line+1, temptext);							
				}
				if (copytext.size() > 2) {
					insertline = line+1;
					for (count = 1; count <= copytext.size() - 2; count++) {
						text.insert(text.begin()+insertline,copytext[count]);
						insertline++;
					}
				}
			}


			if (copytext.size() == 1) {
				if (cursor == 0) {		
					cursor = copytext[0].size();
				}
				else {
					cursor = cursor + copytext[0].size();
				}
			}
			else {
				cursor = copytext[copytext.size()-1].size();
			}
			line = line + copytext.size()-1;
			
			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
			if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();
				
			mark1[0] = -1;
			mark1[1] = -1;
			mark2[0] = -1;
			mark2[1] = -1;
			update();
		}
		
		if (menucursor == 4 && mark2[0] != -1) {
			if (mark2[1] == mark1[1]) {
				text[mark1[1]].erase(mark1[0],mark2[0]-mark1[0]);
			}
			
			if (mark2[1] > mark1[1]) {	
				text[mark1[1]].erase(mark1[0]);
				
				text[mark2[1]] = text[mark2[1]].substr(mark2[0]);
				
				text[mark1[1]] = text[mark1[1]]+text[mark2[1]];
				text.erase(text.begin()+mark2[1]);
				if (mark2[1] - mark1[1] > 1) {
					for (count = mark1[1]+1; count<=mark2[1]-1;count++) text.erase(text.begin()+count);
				}
			}
			cursor = mark1[0];
			line = mark1[1];

			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
			if ((text.size() > minlines) && (scrolly < minlines - text.size())) scrolly = minlines - text.size();
			
			mark1[0] = -1;
			mark1[1] = -1;
			mark2[0] = -1;
			mark2[1] = -1;
			update();
		}
		
	
		if (menucursor == 5) {
			inputcursor = findtext.size();
			menumode = 8;
			wait = 200;
		}
		if (menucursor == 6) {
			bTabbed = false;
			inputcursor = findtext.size();
			menumode = 9;
			wait = 200;
		}
		if (menucursor == 7) {
			inputcursor = gotoline.size();
			menumode = 10;
			wait = 200;
		}
		if (menucursor == 8) {
			found = false;
			for (count = 0; count < bookmark.size(); count++) {
				if (line == bookmark[count]) {
					bookmark.erase(bookmark.begin()+count);
					found = true;
				}
			}
			if (!found) {
				bookmark.push_back(line);
				sort(bookmark.begin(),bookmark.end());
			}
			saveBookmarks(textfile);
		}
		
		if (menucursor == 9 && bookmark.size() > 0) {
			count = 0;
			found = false;
			if (current == bookmark.size()-1) current = 0;
			else current++;
			line = bookmark[current];
			cursor = 0;
			if (line >= text.size()) line = text.size() - 1;
			scrollx = 0;
			if (text.size() > minlines) {
				scrolly = 0 - line;
				if (scrolly < minlines - text.size()) {
					scrolly = minlines - text.size();
				}
			}		
			update();
		}
		bmUpdate = true;
		transition = true;
		menu = 0;
	}
}

void getNotepadMenuInput(void)
{
	int count, loc;
	string readkey, readline;
	ofstream writefile;
	
	if (menumode == 6) {
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (inputcursor < savefile.size()) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}
		}
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    return;
  }
# endif
		if (readkey != "") {
			if (readkey == "bs") {
				if (inputcursor > 0 && savefile.size() > 0) {
					savefile.erase(inputcursor-1,1);
					inputcursor--;
				}
			}
			else if (readkey == "en") {
				if (savefile.size() > 0) {
					openfile = savefile;
					savefile = filedir + "/" + openfile;
					writefile.open(savefile.c_str());
					for (count = 0; count < text.size(); count++) {
						readline = text[count];
						loc = readline.find("     ",0);
						while (loc != string::npos) {							
							readline.replace(loc,5,"\t",1);
							loc = readline.find("     ",0);
						}					
						writefile << readline << endl;
					}
					writefile.close();
					mode = 1;
					menumode = 0;
					wait = 100;
					update();
					transition = true;
					inputcursor = 0;
				}
			}
			else if (savefile.size() < 256) {
					savefile.insert(inputcursor,readkey);
					inputcursor++;
				}
			
			bmUpdate = true;
		}
	}	

	if (menumode == 7) {
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_CROSS) {
				if (dir[dirselect].isDir) {
					findlast = filedir.find_last_of("/");
					if (findlast != string::npos) upcurrentdir = filedir.substr(0,findlast);
					else upcurrentdir = "ms0:";
					
					if (dir[dirselect].name == "..") filedir = upcurrentdir;
					else if (dir[dirselect].name != ".") filedir = filedir + "/" + dir[dirselect].name;
					
					listDirectory(filedir);
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
				}
				else {
					savefile = dir[dirselect].name;
					menumode = 6;
				}
				inputcursor = savefile.size();
				padrelease = false;
				bmUpdate = true;
				transition = true;
			}		
		}
	}
	
	if (menumode == 8) {
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (inputcursor < findtext.size()) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}
		}
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    return;
  }
# endif
		if (readkey != "") {
			if (readkey == "bs") {
				if (inputcursor > 0 && findtext.size() > 0) {
					findtext.erase(inputcursor-1,1);
					inputcursor--;
				}
			}
			else if (readkey == "en") {
				if (findtext.size() > 0) {
					findline = line;
					findfirst = text[findline].find(findtext,cursor);
					findline++;
					while (findfirst == string::npos && findline < text.size()) {
						findfirst = text[findline].find(findtext,0);
						findline++;
					}
					
					if (findfirst != string::npos) {
					
						cursor = findfirst+findtext.size();
						line = findline-1;
						mark1[0] = findfirst;
						mark1[1] = line;
						mark2[0] = cursor;
						mark2[1] = line;

						if ((cursor + scrollx < 0) && (cursor + scrollx > nMaxchar)) scrollx = nMaxchar - cursor - 4;
						if ((line < 0 - scrolly) || (line > minlines - scrolly)) scrolly = 0 - line;						
					}
					update();
					mode = 2;
					menumode = 0;
					wait = 100;
					transition = true;
					inputcursor = 0;
				}
			}
			else  {
				findtext.insert(inputcursor,readkey);
				inputcursor++;
			}
			bmUpdate = true;
		}
	}
	
	if (menumode == 9) {
		if (padUp() || padDown()) {
			bTabbed = !bTabbed;
			if (bTabbed) inputcursor = replacetext.size();
			else inputcursor = findtext.size();
			wait = 120;
			bmUpdate = true;
		}
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (!bTabbed && inputcursor < findtext.size()) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}
			if (bTabbed && inputcursor < replacetext.size()) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}
		}
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    return;
  }
# endif
		if (readkey != "") {
			if (readkey == "     ") {
				bTabbed = !bTabbed;
				if (bTabbed) inputcursor = replacetext.size();
				else inputcursor = findtext.size();
			}
			else if (readkey == "bs") {
				if (!bTabbed) {
					if (inputcursor > 0 && findtext.size() > 0) {
						findtext.erase(inputcursor-1,1);
						inputcursor--;
					}
				}
				else if (inputcursor > 0 && replacetext.size() > 0) {
							replacetext.erase(inputcursor-1,1);
							inputcursor--;
						}
			}
			else if (readkey == "en") {
				if (findtext.size() > 0  && replacetext.size() > 0) {
					findline = line;
					findfirst = text[findline].find(findtext,cursor);
					findline++;
					while (findfirst == string::npos && findline < text.size()) {
						findfirst = text[findline].find(findtext);
						findline++;
					}

					if (findfirst != string::npos) {
						text[findline-1].replace( findfirst, findtext.size(), replacetext.c_str(), replacetext.size());
						cursor = findfirst + replacetext.size();
						line = findline-1;
						mark1[0] = findfirst;
						mark1[1] = line;
						mark2[0] = findfirst + replacetext.size();
						mark2[1] = line;
						
						if ((cursor + scrollx < 0) && (cursor + scrollx > nMaxchar)) scrollx = nMaxchar - cursor - 4;
						if ((line < 0 - scrolly) || (line > minlines - scrolly)) scrolly = 0 - line;
					}
					update();
					mode = 2;
					menumode = 0;
					wait = 100;
					transition = true;
					inputcursor = 0;
				}	
			}
			else  {
				if (!bTabbed) {
					findtext.insert(inputcursor,readkey);
					inputcursor++;
				}
				else {
					replacetext.insert(inputcursor,readkey);
					inputcursor++;
				}
			}
			bmUpdate = true;
		}
	}
		
	if (menumode == 10) {
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (inputcursor < gotoline.size()) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}
		}	
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    return;
  }
# endif
		if (readkey != "") {
			if (readkey == "bs") {
				if (inputcursor > 0 && gotoline.size() > 0) {
					gotoline.erase(inputcursor-1,1);
					inputcursor--;
				}
			}
			else if (readkey == "en") {
				testline = atoi(gotoline.c_str());
				if (testline > 0) {
					line = testline - 1;
					if (line < 0) line = 0;
					if (line > text.size() - 1) line = text.size() - 1;
					cursor = 0;
					scrollx = 0;
					if (text.size() > minlines) {
						scrolly = 0 - line;
						if (scrolly < minlines - text.size()) scrolly = minlines - text.size();	
					}
					update();						
					mode = 2;
					menumode = 0;
					wait = 200;	
					transition = true;
					inputcursor = 0;
				}
			}
			else if (readkey.size() == 1) {
				if (isdigit((int) *readkey.c_str()) && gotoline.size() < 10) {
					gotoline.insert(inputcursor,readkey);
					inputcursor++;
				}
			}
			
			bmUpdate = true;
		}
	}
	if (menumode == 11) {
		if (pad.Buttons & PSP_CTRL_UP) {
			if (colcursor == 1) colcursor = 3;
			else colcursor--;
			
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (colcursor == 3) colcursor = 1;
			else colcursor++;
			
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (colcursor == 1) {
				if (bgcol.r != 0) bgcol.r--;
			}
			if (colcursor == 2) {
				if (bgcol.g != 0) bgcol.g--;
			}
			if (colcursor == 3) {
				if (bgcol.b != 0) bgcol.b--;
			}
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (colcursor == 1) {
				if (bgcol.r != 255) bgcol.r++;
			}
			if (colcursor == 2) {
				if (bgcol.g != 255) bgcol.g++;
			}
			if (colcursor == 3) {
				if (bgcol.b != 255) bgcol.b++;
			}
			bmUpdate = true;
		}

		if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
			backcol = SDL_MapRGB(im_screen->format,bgcol.r,bgcol.g,bgcol.b);
			menumode = 0;
			update();			
			wait = 200;
			saveSettings();
			transition = true;
		}
	}

	if (menumode == 12) {
		if (pad.Buttons & PSP_CTRL_UP) {
			if (colcursor == 1) colcursor = 3;
			else colcursor--;
			
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (colcursor == 3) colcursor = 1;
			else colcursor++;
			
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (colcursor == 1) {
				if (fgcol.r != 0) fgcol.r--;
			}
			if (colcursor == 2) {
				if (fgcol.g != 0) fgcol.g--;
			}
			if (colcursor == 3) {
				if (fgcol.b != 0) fgcol.b--;
			}
			wait = 1;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (colcursor == 1) {
				if (fgcol.r != 255) fgcol.r++;
			}
			if (colcursor == 2) {
				if (fgcol.g != 255) fgcol.g++;
			}
			if (colcursor == 3) {
				if (fgcol.b != 255) fgcol.b++;
			}
			wait = 1;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
			forecol = fgcol;
			menumode = 0;
			update();		
			wait = 200;
			saveSettings();
			transition = true;
		}
	}
}

void drawNotepadText(void)
{
	int endtext, list, count, bm;
	string textscroll;	
	
	if (mode == EDIT && bUpdate) {
		if (mark2[1] > -1) {
			if (mark2[1] == mark1[1]) {
				bm = 9+mark1[1]*ndLine + scrolly*ndLine;
				if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4+mark1[0]*ndCol + scrollx*ndCol, 9+mark1[1]*ndLine + scrolly*ndLine, (mark2[0] - mark1[0])*ndCol+2, ndLine, lightgrey);
			}
			if (mark2[1] > mark1[1]) {
				for (count = mark1[1];count <= mark2[1]; count++) {
					if (count == mark2[1]) {
						bm = 9+mark2[1]*ndLine + scrolly*ndLine;
						if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4 + scrollx*ndCol, 9+mark2[1]*ndLine + scrolly*ndLine, (mark2[0])*ndCol+2, ndLine, lightgrey);
					}
					else if (count == mark1[1]) {
						bm = 9+mark1[1]*ndLine + scrolly*ndLine;
						if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4+mark1[0]*ndCol + scrollx*ndCol, 9+mark1[1]*ndLine + scrolly*ndLine, (text[count].size() - mark1[0])*ndCol+2, ndLine, lightgrey);
					}
					else {
						bm = 9+count*ndLine + scrolly*ndLine;
						if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4 + scrollx*ndCol, 9+count*ndLine + scrolly*ndLine, (text[count].size())*ndCol+2, ndLine, lightgrey);
					}
				}
			}
		}	
	}
		
	if ((mode == KEYBOARD || mode == EDIT) && bUpdate) {
		list = 180;
		for (count = 0 - scrolly; count < minlines - scrolly; count++) {
			if (count < text.size()) {
				if (scrollx < 0) {
					endtext = nMaxchar;
					if (text.at(count).size() < endtext) endtext = text[count].size() + scrollx;
					if (text.at(count).size() > -1-scrollx) textscroll = text.at(count).substr(0 - scrollx, endtext);
					else textscroll = " ";
					drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
				}
				else {
					endtext =  nMaxchar;
					if (text.at(count).size() < endtext) endtext = text[count].size();
					textscroll = text.at(count).substr(0, endtext);
					drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
				}
			}
		}
	}	

	if (mode == FULLSCREEN && bUpdate) {
		list = 260;
		if (wordwrap) {
			for (count = 0 - scrolly; count < maxlines - scrolly; count++) {
				if (count < nWW) {
					drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, wraptext[count], forecol);					
				}
			}
		}
		else {
			for (count = 0 - scrolly; count < maxlines - scrolly; count++) {
				if (count < text.size()) {
					if (scrollx < 0) {
						endtext = nMaxchar;
						if (text.at(count).size() < endtext) endtext = text[count].size() + scrollx;
						if (text.at(count).size() > -1-scrollx) textscroll = text.at(count).substr(0 - scrollx, endtext);
						else textscroll = " ";
						drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
					}
					else {
						endtext =  nMaxchar;
						if (text.at(count).size() < endtext) endtext = text[count].size();
						textscroll = text.at(count).substr(0, endtext);
						drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
					}
				}
			}
		}
	}
}

void displayNotepad(void)
{
	int bm, count;
	char sizestring[50];
	string debugtext;
	
	if (mode == KEYBOARD) {
		sge_Blit(img_textbackground, im_screen, 0,0,0,0,480,200);
		sge_Blit(img_background, im_screen, 0,200, 0, 200, 480, 72);

		if (menumode == 0) drawKeyboard(im_screen);
		drawFrame(im_screen,0,0,480,200);
		for (count = 0; count< bookmark.size(); count++) {
			bm = ndLine*bookmark[count] + ndLine*scrolly;
			if (bm >= 0 and bm <= 170) blit(im_screen,0,bm+12,img_dot);
		}
		sprintf(sizestring, "Ln %d:%d  Col %d",line+1,text.size(),cursor+1);
		drawText(systemfont,im_screen,11, 192,sizestring,sdlwhite);
		drawText(systemfont,im_screen,10, 191,sizestring,sdlblue);
	}
		
	if (mode == EDIT) {
		sge_Blit(img_textbackground, im_screen, 0,0,0,0,480,200);
		sge_Blit(img_background,im_screen, 0,200, 0, 200, 480, 72);
		if (menumode == 0) {
			blit(im_screen,70,210, img_arrows);
			blit(im_screen,240,210, img_editbuttons);
		}
		drawFrame(im_screen,0,0,480,200);
		for (count = 0; count< bookmark.size(); count++) {
			bm = ndLine*bookmark[count] + ndLine*scrolly;
			if (bm >= 0 and bm <= 170) blit(im_screen,0,bm+12,img_dot);
		}


		//debugtext = "Sel1 "+ mark1[1] +":"+mark1[2]+"  Sel2 "+mark2[1]+":"+mark2[2];
		sprintf(sizestring, "Ln %d:%d  Col %d",line+1,text.size(),cursor+1);
		drawText(systemfont,im_screen,11, 192,sizestring,sdlwhite);		
		drawText(systemfont,im_screen,10, 191,sizestring,sdlblue);		
		sprintf(sizestring, "Sel1 %d:%d  Sel2 %d:%d",mark1[0]+1,mark1[1]+1,mark2[0]+1,mark2[1]+1);
		debugtext = sizestring;
		drawText(systemfont,im_screen,471-debugtext.size()*7, 192,debugtext,sdlwhite);
		drawText(systemfont,im_screen,470-debugtext.size()*7, 191,debugtext,sdlblue);
		
	}
		
	if (mode == FULLSCREEN) {
		sge_Blit(img_textbackground, im_screen,0,0,0,0,480,272);
		drawFrame(im_screen,0,0,480,272);
		for (count = 0; count< bookmark2.size(); count++) {
			bm = ndLine*bookmark2[count] + ndLine*scrolly;
			if (bm >= 0 and bm <= 240) blit(im_screen,0,bm+12,img_dot);
		}
		sprintf(sizestring, "Ln %d:%d  Col %d",1-scrolly,text.size(),cursor+1);
		drawText(systemfont,im_screen,11, 263,sizestring,sdlwhite);
		drawText(systemfont,im_screen,10, 262,sizestring,sdlblue);			
		//blx = 0;
	}


		
	if (mode >= KEYBOARD && mode <= FULLSCREEN) {
		drawText(systemfont,im_screen,240-openfile.size()*6/2-1,-1, openfile,sdlwhite);
		drawText(systemfont,im_screen,240-openfile.size()*6/2,0, openfile,sdlblack);
		if ((10 + line*ndLine + scrolly*ndLine) > 0 && (line + scrolly) < minlines && (9 + cursor*ndCol + scrollx*ndCol) >= 6) {
			//drawVline(im_screen,9+ cursor * ndCol + scrollx*ndCol - 4, 12+line*ndLine + scrolly*ndLine - 2, ndLine, cursorcol);
			blx = 9+ cursor * ndCol + scrollx*ndCol - 4;
			bly = 12+line*ndLine + scrolly*ndLine - 2;
			blh = ndLine;
			if (mode == FULLSCREEN) blx = 0;
		}
		else blx = 0;
	}
}

void displayNotepadMenu(void)
{
	string textscroll;
	char sizestring[255];
	
	if (menumode == 6) {
		//blit(im_screen,0,0, img_background);

		drawKeyboard(im_screen);
		drawMenuFrame(im_screen);
		
		drawFillRect(im_screen,177,47,260,16,white);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);
		drawFillRect(im_screen,176,66,260,16,grey);
		drawRect(im_screen,177,67,260,16,black);
		drawRect(im_screen,176,66,260,16,grey);
		
		drawText(font,im_screen,40, 50, "Name:            ",sdlblack);
		drawText(font,im_screen,40, 70, "Save in folder:  ",sdlblack);
		
		if (savefile.size() > nMaxinput) {
			if (inputcursor < savefile.size() - nMaxinput) textscroll = savefile.substr(inputcursor,nMaxinput);
			else textscroll = savefile.substr(savefile.size()-nMaxinput);
		}
		else textscroll = savefile;
		drawText(font,im_screen,180,50, textscroll.c_str(), sdlblack);
		//drawVline(im_screen,181+textscroll.size()*nCol, 48, nLine, cursorcol);
		if (savefile.size() <= nMaxinput) blx = 180+inputcursor*nCol;
		else {
			if (inputcursor < savefile.size() - nMaxinput) blx = 180;
			else blx = 180+(nMaxinput)*nCol-savefile.size()*nCol+inputcursor*nCol;
		}
		bly = 48;
		blh = nLine;
		
		if (currentdir.size() > nMaxinput) textscroll = currentdir.substr(0,nMaxinput);
		else textscroll = currentdir;
		drawText(font,im_screen,180,70, textscroll.c_str(), sdlblack);

		drawText(font,im_screen,40,100, "Press Start to change folder or select a file name", sdlblue);
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Enter to save", sdlblue);

		drawText(font,im_screen,216,17,"Save As", sdlblack);
	}
	
	if (menumode == 8) {

		drawKeyboard(im_screen);
		drawMenuFrame(im_screen);	
		
		drawFillRect(im_screen,176,46,260,16,white);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);

		drawText(font,im_screen, 40, 50, "Search String:            ",sdlblack);
		
		if (findtext.size() > nMaxinput) {
			if (inputcursor < findtext.size() - nMaxinput) textscroll = findtext.substr(inputcursor,nMaxinput);
			else textscroll = findtext.substr(findtext.size()-nMaxinput);
		}
		else textscroll = findtext;
		drawText(font,im_screen,180,50, textscroll.c_str(), sdlblack);
		//drawVline(im_screen,180+textscroll.size()*nCol, 48, nLine, cursorcol);
		if (findtext.size() <= nMaxinput) blx = 180+inputcursor*nCol;
		else {
			if (inputcursor < findtext.size() - nMaxinput) blx = 180;
			else blx = 180+(nMaxinput)*nCol-findtext.size()*nCol+inputcursor*nCol;
		}
		bly = 48;
		blh = nLine;
		
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Enter to search", sdlblue);
		drawText(font,im_screen,208,17,"Find Text", sdlblack);
	}

	if (menumode == 9) {

		drawKeyboard(im_screen);
		drawMenuFrame(im_screen);
		
		if (!bTabbed) {
			drawFillRect(im_screen,176,46,260,16,white);
			drawRect(im_screen,177,47,260,16,black);
			drawRect(im_screen,176,46,260,16,grey);
		}
		else {
			drawFillRect(im_screen,176,46,260,16,grey);
			drawRect(im_screen,177,47,260,16,black);
			drawRect(im_screen,176,46,260,16,grey);
		}
		
		if (bTabbed) {		
			drawFillRect(im_screen,176,66,260,16,white);
			drawRect(im_screen,177,67,260,16,black);
			drawRect(im_screen,176,66,260,16,grey);
		}
		else {
			drawFillRect(im_screen,176,66,260,16,grey);
			drawRect(im_screen,177,67,260,16,black);
			drawRect(im_screen,176,66,260,16,grey);
		}
		drawText(font,im_screen,40, 50, "Search String:",sdlblack);
		drawText(font,im_screen,40, 70, "Replace with:",sdlblack);
		
		if (findtext.size() > nMaxinput) {
			if (!bTabbed) {
				if (inputcursor < findtext.size() - nMaxinput) textscroll = findtext.substr(inputcursor,nMaxinput);
				else textscroll = findtext.substr(findtext.size()-nMaxinput);
			}
			else textscroll = findtext.substr(0,nMaxinput);
		}else textscroll = findtext;
		drawText(font,im_screen,180,50, textscroll, sdlblack);
		if (!bTabbed) {
			//drawVline(im_screen,180+textscroll.size()*nCol, 48, nLine, cursorcol);
			if (findtext.size() <= nMaxinput) blx = 180+inputcursor*nCol;
			else {
				if (inputcursor < findtext.size() - nMaxinput) blx = 180;
				else blx = 180+(nMaxinput)*nCol-findtext.size()*nCol+inputcursor*nCol;
			}
			bly = 48;
			blh = nLine;
		}
		
		if (replacetext.size() > nMaxinput) {
			if (bTabbed) {
				if (inputcursor < replacetext.size() - nMaxinput) textscroll = replacetext.substr(inputcursor,nMaxinput);
				else textscroll = replacetext.substr(replacetext.size()-nMaxinput);
			}
			else textscroll = replacetext.substr(0,nMaxinput);
		}
		else textscroll = replacetext;
		drawText(font,im_screen,180,70, textscroll, sdlblack);
		if (bTabbed) {
			//drawVline(im_screen,180+textscroll.size()*nCol, 68, nLine, cursorcol);
			if (replacetext.size() <= nMaxinput) blx = 180+inputcursor*nCol;
			else {
				if (inputcursor < replacetext.size() - nMaxinput) blx = 180;
				else blx = 180+(nMaxinput)*nCol-replacetext.size()*nCol+inputcursor*nCol;
			}
			bly = 68;
			blh = nLine;
		}
		
		if (!bTabbed) drawText(font,im_screen,40,100, "Press Tab to input replacement text", sdlblue);
		else drawText(font,im_screen,40,100, "Press Tab to input search string", sdlblue);
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Enter to replace", sdlblue);
		drawText(font,im_screen,198,17,"Replace Text", sdlblack);
	}
	
	if (menumode == 10) {

		drawKeyboard(im_screen);
		drawMenuFrame(im_screen);
		
		drawFillRect(im_screen,176,46,260,16,white);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);

		drawText(font,im_screen,40, 50, "Go to Line:",sdlblack);
		
		if (gotoline.size() > nMaxinput) textscroll = gotoline.substr(gotoline.size()-nMaxinput);
		else textscroll = gotoline;
		drawText(font,im_screen,180,50, textscroll, sdlblack);
		//drawVline(im_screen,180+textscroll.size()*nCol, 48, nLine, cursorcol);
		if (gotoline.size() <= nMaxinput) blx = 180+inputcursor*nCol;
		else blx = 180+nMaxinput*nCol;
		bly = 48;
		blh = nLine;
		
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Enter to jump to line", sdlblue);
		drawText(font,im_screen,222,17,"Go To", sdlblack);
	}
	
	if (menumode == 11) {
		drawMenuFrame(im_screen);
		
		if (colcursor == 1) drawTextShadowed(font,im_screen,40, 50, "Red:", sdlred);
		else drawText(font,im_screen,40, 50, "Red:" ,sdlblack);
		if (colcursor == 2) drawTextShadowed(font,im_screen,40, 70, "Green:", sdlgreen);
		else drawText(font,im_screen,40, 70, "Green:" ,sdlblack);
		if (colcursor == 3) drawTextShadowed(font,im_screen,40, 90, "Blue:", sdlblue);
		else drawText(font,im_screen,40, 90, "Blue:" ,sdlblack);
		sprintf(sizestring,"%d",bgcol.r);
		drawText(font,im_screen,365, 50, sizestring ,sdlblack);
		sprintf(sizestring,"%d",bgcol.g);
		drawText(font,im_screen,365, 70, sizestring ,sdlblack);
		sprintf(sizestring,"%d",bgcol.b);
		drawText(font,im_screen,365, 90, sizestring ,sdlblack);
		
		drawFillRect(im_screen,100,55,255,2,grey);
		drawFillRect(im_screen,100,75,255,2,grey);
		drawFillRect(im_screen,100,95,255,2,grey);
		
		drawFillRect(im_screen,99+bgcol.r,53,3,5,darkgrey);
		drawFillRect(im_screen,99+bgcol.g,73,3,5,darkgrey);
		drawFillRect(im_screen,99+bgcol.b,93,3,5,darkgrey);
		
		drawFillRect(im_screen,400,50,30,20,SDL_MapRGB(im_screen->format,bgcol.r,bgcol.g,bgcol.b));
		drawRect(im_screen,400,50,30,20,black);

		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Cross to select color", sdlblue);
		drawText(font,im_screen,184,17,"Background Color", sdlblack);
		blx = 0;
	}
	
	if (menumode == 12) {

		drawMenuFrame(im_screen);
		
		if (colcursor == 1) drawTextShadowed(font,im_screen,40, 50, "Red:", sdlred);
		else drawText(font,im_screen,40, 50, "Red:" ,sdlblack);
		if (colcursor == 2) drawTextShadowed(font,im_screen,40, 70, "Green:", sdlgreen);
		else drawText(font,im_screen,40, 70, "Green:" ,sdlblack);
		if (colcursor == 3) drawTextShadowed(font,im_screen,40, 90, "Blue:", sdlblue);
		else drawText(font,im_screen,40, 90, "Blue:" ,sdlblack);
		sprintf(sizestring,"%d",fgcol.r);
		drawText(font,im_screen,365, 50, sizestring ,sdlblack);
		sprintf(sizestring,"%d",fgcol.g);
		drawText(font,im_screen,365, 70, sizestring ,sdlblack);
		sprintf(sizestring,"%d",fgcol.b);
		drawText(font,im_screen,365, 90, sizestring ,sdlblack);
		
		drawFillRect(im_screen,100,55,255,2,grey);
		drawFillRect(im_screen,100,75,255,2,grey);
		drawFillRect(im_screen,100,95,255,2,grey);
		
		drawFillRect(im_screen,99+fgcol.r,53,3,5,darkgrey);
		drawFillRect(im_screen,99+fgcol.g,73,3,5,darkgrey);
		drawFillRect(im_screen,99+fgcol.b,93,3,5,darkgrey);
		
		drawFillRect(im_screen,400,50,30,20,SDL_MapRGB(im_screen->format,fgcol.r,fgcol.g,fgcol.b));
		drawRect(im_screen,400,50,30,20,black);
		
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Cross to select color", sdlblue);
		drawText(font,im_screen,205,17,"Text Color", sdlblack);
		blx = 0;
	}
}

void displayNotepadDropMenu(void)
{

	blit(im_screen, 0,0, img_menubar);
	if (menu == 1) {
		drawFillRect(im_screen,8,0,32,10,darkgrey);
	}
	if (menu == 2) {
		drawFillRect(im_screen,58,0,32,10,darkgrey);
	}
	if (menu == 3) {
		drawFillRect(im_screen,108,0,32,10,darkgrey);
	}
	if (menu == 4) {
		drawFillRect(im_screen,158,0,39,10,darkgrey);
	}
	drawText(font,im_screen,11,0, "File", sdlblack);
	if (menu != 2) drawText(font,im_screen,61,0, "Edit", sdlblack);
	if (menu == 2) drawText(font,im_screen,60,0, "Edit", sdlwhite);
	drawText(font,im_screen,111,0, "View", sdlblack);
	if (isplaying) drawText(font,im_screen,161,0, "Music", sdlblack);
	else drawText(font,im_screen,161,0, "Music", sdldarkgrey);
			
	if (menu == 2) {
		int menupos = 60;
		drawText(font,im_screen,menupos,0, "Edit", sdlwhite);

		drawDropmenu(im_screen, menupos, 11, 15, 9);
		
		drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*15-8, nLine, blue);		
		
		if (menucursor == 1) drawTextShadowed(font,im_screen,menupos+20, nLine+4, "Cut", sdlwhite);
		else drawText(font,im_screen,menupos+20, nLine+4, "Cut", sdlblack);
		
		if (menucursor == 2) drawTextShadowed(font,im_screen,menupos+20,2*nLine+4, "Copy", sdlwhite);
		else drawText(font,im_screen,menupos+20,2*nLine+4, "Copy", sdlblack);
		
		if (menucursor == 3) drawTextShadowed(font,im_screen,menupos+20,3*nLine+4, "Paste", sdlwhite);
		else drawText(font,im_screen,menupos+20,3*nLine+4, "Paste", sdlblack);
		
		if (menucursor == 4) drawTextShadowed(font,im_screen,menupos+20,4*nLine+4, "Clear", sdlwhite);
		else drawText(font,im_screen,menupos+20,4*nLine+4, "Clear", sdlblack);
		
		if (menucursor == 5) drawTextShadowed(font,im_screen,menupos+20,5*nLine+4, "Find", sdlwhite);
		else drawText(font,im_screen,menupos+20,5*nLine+4, "Find", sdlblack);
		
		if (menucursor == 6) drawTextShadowed(font,im_screen,menupos+20,6*nLine+4, "Replace", sdlwhite);
		else drawText(font,im_screen,menupos+20,6*nLine+4, "Replace", sdlblack);
		
		if (menucursor == 7) drawTextShadowed(font,im_screen,menupos+20,7*nLine+4, "Goto", sdlwhite);
		else drawText(font,im_screen,menupos+20,7*nLine+4, "Goto", sdlblack);
		
		if (menucursor == 8) drawTextShadowed(font,im_screen,menupos+20,8*nLine+4, "Toggle Bookmark", sdlwhite);
		else drawText(font,im_screen,menupos+20,8*nLine+4, "Toggle Bookmark", sdlblack);
		
		if (menucursor == 9) drawTextShadowed(font,im_screen,menupos+20,9*nLine+4, "Goto Bookmark", sdlwhite);
		else drawText(font,im_screen,menupos+20,9*nLine+4, "Goto Bookmark", sdlblack);
	}
}		

void textWrap1(void) {
	int lenw, fl, count;
	string temp, trunctext;
	
	wraptext.clear();
	wraptext = text;
	nWW = wraptext.size();
	count = 0;
	while (count < wraptext.size()) {
		lenw = wraptext[count].size();
		if (lenw > nMaxchar) {
			
			fl = wraptext[count].find_last_of(" ", nMaxchar);
			
			if (fl == string::npos) {
				trunctext = wraptext[count].substr(nMaxchar+1);
				wraptext[count] = wraptext[count].substr(0,nMaxchar);
			}
			else {
				trunctext = wraptext[count].substr(fl+1);
				wraptext[count] = wraptext[count].substr(0, fl);
			}
			wraptext.insert(wraptext.begin()+count+1, trunctext);											
		}
		count++;
	}
	nWW = wraptext.size();
}

void textWrap2(void) {
	int lenw, fl, count;
	string temp, trunctext;
	
	wraptext.clear();
	wraptext = text;
	nWW = wraptext.size();
	count = 0;
	while (count < wraptext.size()) {
		lenw = wraptext[count].size();
		if (lenw > nMaxchar) {
			if (count == wraptext.size()-1) wraptext.push_back("");
			fl = wraptext[count].find_last_of(" ", nMaxchar);
			if (fl == string::npos) {
				trunctext = wraptext[count].substr(nMaxchar+1);
				if (wraptext[count+1].substr(0,1) == " ") wraptext.insert(wraptext.begin()+count+1, trunctext);
				else if (wraptext[count+1].size() > 0) wraptext[count+1] = trunctext + " " + wraptext[count+1];
				else {
					wraptext[count+1] = trunctext;
					wraptext.insert(wraptext.begin()+count+2, "");
				}													
				wraptext[count] = wraptext[count].substr(0,nMaxchar);
			}
			else {
				trunctext = wraptext[count].substr(fl+1);
				if (wraptext[count+1].substr(0,1) == " ") wraptext.insert(wraptext.begin()+count+1, trunctext);			
				else if (wraptext[count+1].size() > 0) wraptext[count+1] = trunctext + " " + wraptext[count+1];
				else {
					wraptext[count+1] = trunctext;
					wraptext.insert(wraptext.begin()+count+2, "");
				}		
				wraptext[count] = wraptext[count].substr(0, fl);
			}										
		}
		count++;
	}
	nWW = wraptext.size();
}

void toggleBookmark(void)
{
	bool found = false;
	int count;
	
	for (count = 0; count < bookmark2.size(); count++) {
		if (0-scrolly == bookmark2[count]) {
			bookmark2.erase(bookmark2.begin()+count);
			found = true;
		}
	}
	if (!found) {
		bookmark2.push_back(0-scrolly);
		sort(bookmark2.begin(),bookmark2.end());
	}
	saveBookmarks(textfile);
}

void gotoBookmark(void)
{
	if (bookmark2.size() > 0)
	{
		if (current2 == bookmark2.size()-1) current2 = 0;
		else current2++;
		scrolly = 0-bookmark2[current2];
		update();
	}
}

void loadBookmarks(string filename) {
	int count, findfirst;
	string readline;
	Sint32 loc;
	ifstream file("bookmark.dat");
	char * pch;
	
	bookmarkdat.clear();
	while (getline(file,readline,'\n')) {
		
		loc = readline.find((char) 13,0);
		if (loc != string::npos) readline.resize(readline.size()-1);
		bookmarkdat.push_back(readline);
	}
	file.close();
	if (bookmarkdat.size() > 0) {
		count = 0;
		while (filename != bookmarkdat[count]) {
			count++;
			if (count == bookmarkdat.size()) break;
		}
		if (count != bookmarkdat.size()) {
			bookmark.clear();			
			if (bookmarkdat[count+1].size() > 0) {
				pch = strtok (const_cast <char *> (bookmarkdat[count+1].c_str())," ");
				while (pch != NULL)
				{
					bookmark.push_back(atoi(pch));
					pch = strtok (NULL, " ");
					
				}				
			}
						
		}
		if (count != bookmarkdat.size()) {
			bookmark2.clear();
			if (bookmarkdat[count+2].size() > 0) {
				pch = strtok (const_cast <char *> (bookmarkdat[count+2].c_str())," ");
				while (pch != NULL)
				{
					bookmark2.push_back(atoi(pch));
					pch = strtok (NULL, " ");
				}					
			}
		}		
	}
}


void saveBookmarks(string filename) {
	int count, a;
	string ilist = "";
	char sizestring[50];
	ofstream writefile;

	count = 0;
	if (bookmarkdat.size() > 0) {
	
		while (filename != bookmarkdat[count]) {
			count++;
			if (count == bookmarkdat.size()) {
				break;
			}
		}
	}
	
	if (count != bookmarkdat.size()) {
		bookmarkdat.erase(bookmarkdat.begin()+count);
		bookmarkdat.erase(bookmarkdat.begin()+count);
		bookmarkdat.erase(bookmarkdat.begin()+count);
	}
	
	bookmarkdat.push_back(filename);
	for (a = 0; a < bookmark.size(); a++) {
		sprintf(sizestring,"%d ",bookmark[a]);
		ilist += sizestring;
	}
	bookmarkdat.push_back(ilist);
	ilist = "";
	for (a = 0; a < bookmark2.size(); a++) {
		sprintf(sizestring,"%d ",bookmark2[a]);
		ilist += sizestring;
	}
	bookmarkdat.push_back(ilist);	
		
	writefile.open("bookmark.dat");
	for (count = 0; count < bookmarkdat.size(); count++) {		
		writefile << bookmarkdat[count] << endl;
	}
	writefile.close();		
}

void update(void) 
{
	bUpdate = true;
	bmUpdate = true;
	SDL_FillRect(img_textbackground,NULL, backcol);
}

void setWordwrap(void)
{
	if (wordwrap) {
		if (wordwrap1) {
			textWrap1();
		}
		if (wordwrap2) {
			textWrap2();
		}
	}
	clearMarks();
}

void setWordwrap1(void)
{
	wordwrap1 = !wordwrap1;
	if (wordwrap1) {
		wordwrap = true;
		textWrap1();
	}
	else wordwrap = false;
	wordwrap2 = false;
	update();
}

void setWordwrap2(void)
{
	wordwrap2 = !wordwrap2;
	if (wordwrap2) {
		textWrap2();
		wordwrap = true;
	}
	else wordwrap = false;
	wordwrap1 = false;
	update();
}

bool getWordwrap1(void)
{
	return wordwrap1;
}

bool getWordwrap2(void)
{
	return wordwrap2;
}

void clearMarks(void)
{
	mark1[0] = -1;
	mark1[1] = -1;
	mark2[0] = -1;
	mark2[1] = -1;
}

void scrollText(void)
{
	if (text.size() > minlines && (scrolly + text.size() < minlines))
	{
		scrolly = minlines - text.size();
	}
}
